#!/usr/bin/perl
use strict;
my $ok = "<b style='background:#1a1;color:#fff;padding:2px;'>OK</b>";
my $err = "<b>Fail</b>";

my @modules =
(                                                   
    {module=>'CGI', file=>'CGI.pm', redhat=>'perl-CGI', debian=>'libcgi-pm-perl'}, 
    {module=>'DBI', file=>'DBI.pm', redhat=>'perl-DBI', debian=>'libdbi-perl'}, 
    {module=>'DBD::mysql', file=>'DBD/mysql.pm', redhat=>'perl-DBD-MySQL', debian=>'libdbd-mysql-perl'}, 
    {module=>'Digest::SHA', file=>'Digest/SHA.pm', redhat=>'perl-Digest-SHA', debian=>'libdigest-sha-perl'},
    {module=>'LWP', file=>'LWP/UserAgent.pm', redhat=>'perl-libwww-perl', debian=>'libwww-perl'},
    {module=>'Crypt::SSLeay', file=>'Crypt/SSLeay.pm', redhat=>'perl-Crypt-SSLeay', debian=>'libcrypt-ssleay-perl'},
    {module=>'Time::HiRes', file=>'Time/HiRes.pm', redhat=>'perl-Time-HiRes', debian=>''},
);

my @failed_modules = grep { ! eval { require $_->{file} } && $@ } @modules;
my %is_failed = map { $_->{module} => 1 } @failed_modules;

my @redhat_pkgs = map { $_->{redhat} } @failed_modules if -e '/usr/bin/yum';
my @debian_pkgs = map { $_->{debian} } @failed_modules if -e '/usr/bin/apt-get';

print "Content-type: text/html\n\n";
print "Testing modules...<br><br>\n";
print "<table style='width: 320px'>\n";

for(@modules)
{
   my $status = $is_failed{ $_->{module} } ? $err : $ok;
   print "<tr><td><b>$_->{module}...</b></td><td>$status</td></tr>\n";
}

print "</table><br>\n";

if(@failed_modules)
{
   print "It looks like there are some Perl modules are missing.<br>\n";
   print "You can install all of them at once by issuing the following command from root SSH console:<br><br>\n" if @redhat_pkgs || @debian_pkgs;
   printf ("<font style='font-family: monospace'>yum install %s</font>", join(' ', @redhat_pkgs)) if @redhat_pkgs;
   printf ("<font style='font-family: monospace'>apt-get install %s</font>", join(' ', @debian_pkgs)) if @debian_pkgs;
}
else
{
   print "Everything is ready.\n";
}
